import logging
from bzrlib.plugin import load_plugins
load_plugins()
from bzrlib import branch as bzr_branch
from tarmac.branch import Branch as TarmacBranch
from tarmac.branch import BranchConfig
from jlp import get_config_option


class Branch(TarmacBranch):
    def __init__(self, lp_branch, config=False, target=None, launchpad=None):
        super(Branch, self).__init__(lp_branch, config, target, launchpad)
        self.lp_branch = lp_branch
        self.branch_url = ('bzr+ssh://' +
                           get_config_option('launchpad_login') +
                           '@bazaar.launchpad.net/' +
                           self.lp_branch.unique_name)
        self.bzr_branch = bzr_branch.Branch.open(self.branch_url)
        if config:
            self.config = BranchConfig(lp_branch, config)
        else:
            self.config = None

        self.target = target
        self.logger = logging.getLogger('jenkins-launchpad-plugin')
