from jlp import DputRunner
import os


def dput():
    ppa = os.getenv('ppa_target')
    trunk = os.getenv('trunk')
    packaging_branch = os.getenv('packaging_branch')
    revision = os.getenv('merge_revision')
    debfullname = os.getenv('DEBFULLNAME')
    debemail = os.getenv('DEBEMAIL')
    distributions = os.getenv('distributions')
    jenkins_build_number = os.getenv('jenkins_build_number')
    version_string_format = os.getenv('version_string_format')
    hooks = os.getenv('hooks')
    release_only = os.getenv('release_only')

    # jenkins will add double quotes when a variable ends with '}', strip them
    if version_string_format:
        version_string_format = version_string_format.strip('"')

    if not hooks:
        hooks = []
    else:
        hooks = hooks.split(',')

    if (not ppa or not trunk or not debfullname or
            not debemail or not distributions):
        print ('One of the required variables is missing (ppa_target, ' +
               'trunk, DEBFULLNAME, DEBEMAIL, distributions)')
        return 1

    dputRunner = DputRunner(ppas=ppa.split(','),
                            trunk=trunk,
                            packagingBranch=packaging_branch,
                            revision=revision,
                            DEBEMAIL=debemail,
                            DEBFULLNAME=debfullname,
                            distributions=distributions.split(','),
                            versionFormat=version_string_format,
                            jenkinsBuildNumber=jenkins_build_number,
                            hooks=hooks,
                            release_only=release_only)
    if dputRunner.dput():
        return 0
    else:
        return 1
