import json
import urllib2


class JSONJenkins():
    urllib_opener = None

    def __init__(self, jenkins_url, jenkins_proxy_url, username, password):
        self.jenkins_url = jenkins_url
        self.jenkins_proxy_url = jenkins_proxy_url

        passman = urllib2.HTTPPasswordMgrWithDefaultRealm()
        passman.add_password(None, jenkins_url, username, password)
        authhandler = urllib2.HTTPBasicAuthHandler(passman)
        self.urllib_opener = urllib2.build_opener(authhandler)
        urllib2.install_opener(self.urllib_opener)

    def patch_url(self, url):
        # Test for presence of a url that needs to be patched.
        # When behind a proxy, jenkins-launchpad-plugin can be configured
        # to communicate directly with the backend URL. However, data
        # retreived from jenkins API calls will have the proxified URL.
        # These URLs need to be patched to use the backend URL.
        if self.jenkins_url and self.jenkins_proxy_url:
            if url.startswith(self.jenkins_proxy_url):
                return self.jenkins_url + url[len(self.jenkins_proxy_url):]
        return url

    def get_json_data(self, url, append_api=True):
        url = self.patch_url(url)
        if append_api:
            url = url + '/api/json'
        data = urllib2.urlopen(url)
        return json.load(data)
